JavaScript Data GridColumn virtualization

Render hundreds of columns without freezing the browser, using column virtualization.

Overview

To process a large number of columns in a browser Handsontable utilizes the virtualization process to display only the visible part of the grid with a small offset for a better scrolling experience.

This feature is enabled by default and can be turned off by setting the renderAllColumns option to true.

Configure the column virtualization

You can experiment with the viewportColumnRenderingOffset config option, which determines the number of columns being displayed outside the visible viewport. If the number passed to that option is greater than the total columns in your data set, the virtualization will be practically turned off.

To make the grid scrollable, set the constant width and height to same as the container holding Handsontable and height and set the overflow property to hidden in the container's stylesheet. If the table contains enough rows or columns, it will be scrollable.

The scrolling performance depends mainly on four factors:

  • Number of cells - number of rows multiplied by the number of columns
  • Amount and complexity of custom renderers in cells
  • Number of options enabled in the configuration
  • Performance of your setup - physical machine and browser

The demo below presents a data grid displaying one million cells (1000 rows x 1000 columns).

import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// generate an array of arrays with dummy data
const data = new Array(1000) // number of rows
  .fill(null)
  .map((_, row) =>
    new Array(1000) // number of columns
      .fill(null)
      .map((_, column) => `${row}, ${column}`)
  );

const container = document.querySelector('#example1');

new Handsontable(container, {
  themeName: 'ht-theme-main',
  data,
  colWidths: 100,
  width: '100%',
  height: 320,
  rowHeaders: true,
  colHeaders: true,
  autoWrapRow: true,
  autoWrapCol: true,
  licenseKey: 'non-commercial-and-evaluation',
});

Known limitations

Using column virtualization has the following side effects:

  • The browser's native search will work only for the visible part of the grid.
  • Screen readers may announce the wrong total number of columns. Read more in the Accessibility guide.

Skip to content

Column virtualization

Render hundreds of columns without freezing the browser, using column virtualization.

Overview

To process a large number of columns in a browser Handsontable utilizes the virtualization process to display only the visible part of the grid with a small offset for a better scrolling experience.

This feature is enabled by default and can be turned off by setting the renderAllColumns option to true.

Configure the column virtualization

You can experiment with the viewportColumnRenderingOffset config option, which determines the number of columns being displayed outside the visible viewport. If the number passed to that option is greater than the total columns in your data set, the virtualization will be practically turned off.

To make the grid scrollable, set the constant width and height to same as the container holding Handsontable and height and set the overflow property to hidden in the container’s stylesheet. If the table contains enough rows or columns, it will be scrollable.

The scrolling performance depends mainly on four factors:

  • Number of cells - number of rows multiplied by the number of columns
  • Amount and complexity of custom renderers in cells
  • Number of options enabled in the configuration
  • Performance of your setup - physical machine and browser

The demo below presents a data grid displaying one million cells (1000 rows x 1000 columns).

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
// generate an array of arrays with dummy data
const data = new Array(1000) // number of rows
.fill(null)
.map((_, row) =>
new Array(1000) // number of columns
.fill(null)
.map((_, column) => `${row}, ${column}`)
);
const hotSettings = ref<GridSettings>({
data,
colWidths: 100,
width: '100%',
height: 320,
rowHeaders: true,
colHeaders: true,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Known limitations

Using column virtualization has the following side effects:

  • The browser’s native search will work only for the visible part of the grid.
  • Screen readers may announce the wrong total number of columns. Read more in the Accessibility guide.

Related guides

Configuration options

React Data GridColumn virtualization

Render hundreds of columns without freezing the browser, using column virtualization.

Overview

To process a large number of columns in a browser Handsontable utilizes the virtualization process to display only the visible part of the grid with a small offset for a better scrolling experience.

This feature is enabled by default and can be turned off by setting the renderAllColumns option to true.

Configure the column virtualization

You can experiment with the viewportColumnRenderingOffset config option, which determines the number of columns being displayed outside the visible viewport. If the number passed to that option is greater than the total columns in your data set, the virtualization will be practically turned off.

To make the grid scrollable, set the constant width and height to same as the container holding Handsontable and height and set the overflow property to hidden in the container's stylesheet. If the table contains enough rows or columns, it will be scrollable.

The scrolling performance depends mainly on four factors:

  • Number of cells - number of rows multiplied by the number of columns
  • Amount and complexity of custom renderers in cells
  • Number of options enabled in the configuration
  • Performance of your setup - physical machine and browser

The demo below presents a data grid displaying one million cells (1000 rows x 1000 columns).

import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

// generate an array of arrays with dummy data
const data = new Array(1000) // number of rows
  .fill(null)
  .map((_, row) =>
    new Array(1000) // number of columns
      .fill(null)
      .map((_, column) => `${row}, ${column}`)
  );

const ExampleComponent = () => {
  return (
    <HotTable
      themeName="ht-theme-main"
      data={data}
      colWidths={100}
      width="100%"
      height={320}
      rowHeaders={true}
      colHeaders={true}
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
    />
  );
};

export default ExampleComponent;

Known limitations

Using column virtualization has the following side effects:

  • The browser's native search will work only for the visible part of the grid.
  • Screen readers may announce the wrong total number of columns. Read more in the Accessibility guide.

Angular Data GridColumn virtualization

Render hundreds of columns without freezing the browser, using column virtualization.

Overview

To process a large number of columns in a browser Handsontable utilizes the virtualization process to display only the visible part of the grid with a small offset for a better scrolling experience.

This feature is enabled by default and can be turned off by setting the renderAllColumns option to true.

Configure the column virtualization

You can experiment with the viewportColumnRenderingOffset config option, which determines the number of columns being displayed outside the visible viewport. If the number passed to that option is greater than the total columns in your data set, the virtualization will be practically turned off.

To make the grid scrollable, set the constant width and height to same as the container holding Handsontable and height and set the overflow property to hidden in the container's stylesheet. If the table contains enough rows or columns, it will be scrollable.

The scrolling performance depends mainly on four factors:

  • Number of cells - number of rows multiplied by the number of columns
  • Amount and complexity of custom renderers in cells
  • Number of options enabled in the configuration
  • Performance of your setup - physical machine and browser

The demo below presents a data grid displaying one million cells (1000 rows x 1000 columns).

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from "@handsontable/angular-wrapper";

@Component({
  selector: 'app-example1',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  // generate an array of arrays with dummy data
  readonly hotData = new Array(1000) // number of rows
    .fill(null)
    .map((_, row) =>
      new Array(1000) // number of columns
        .fill(null)
        .map((_, column) => `${row}, ${column}`)
    );

  readonly hotSettings: GridSettings = {
    colWidths: 100,
    width: '100%',
    height: 320,
    rowHeaders: true,
    colHeaders: true,
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Known limitations

Using column virtualization has the following side effects:

  • The browser's native search will work only for the visible part of the grid.
  • Screen readers may announce the wrong total number of columns. Read more in the Accessibility guide.